﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace LegoVez
{
    public partial class Form1 : Form
    {
        private Graphics g;
        private Point Velikost;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FileStream s = null;
            try
            {
                OpenFileDialog ofd = new OpenFileDialog();
                ofd.ShowDialog();
                s = (FileStream)ofd.OpenFile();
                //Otevreni souboru

                using (StreamReader sr = new StreamReader(s))
                {
                    g = this.CreateGraphics();
                    g.Clear(SystemColors.Control);
                    //Vycisteni kreslici plochy

                    int pocetRadku = File.ReadLines(s.Name).Count();

                    string[] separators = new string[] { "", " " };
                    string[] velikostVeze = sr.ReadLine().Split(separators, StringSplitOptions.RemoveEmptyEntries);
                    //Rozdelovani textu

                    Velikost = new Point(int.Parse(velikostVeze[0]), int.Parse(velikostVeze[1]));

                    //Nacte soubor a nastavi potrebne udaje

                    for (int i = 0; i < pocetRadku; i++)
                    {
                        string radek = sr.ReadLine();
                        if (radek != null && radek != "")
                        {
                            string[] specifikace = radek.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

                            if (specifikace.Length > 0)
                            {
                                string[] velikosti = specifikace[4].Split(new char[] { 'X', 'x' });
                                VykresliKostku(int.Parse(specifikace[0]), new Point(int.Parse(specifikace[1]), int.Parse(specifikace[2])), specifikace[3].ToCharArray()[0], new Point(int.Parse(velikosti[0]), int.Parse(velikosti[1])), true);

                                //Radek po radku cte zapis, odstranuje z nej mezery a vykresluje
                            }
                        }
                    }
                    sr.Close();
                }
            }
            catch { }
        }
        private void VykresliKostku(int patro, Point pos, char barva, Point velikost, bool canAdd)
        {
            //1 jednotka 20px
            int vyska = this.Size.Height;
            Pen p = new Pen(Brushes.Black, 2);
            Pen p2 = new Pen(Brushes.Red, 3);

            if (checkBox1.Checked) //Vykresli i horni a bocni stenu, jako prostorove zobrezeni
            {
                //Kreseni
                g.DrawPolygon(p, new Point[] {new Point(pos.X * 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10)
                , new Point(pos.X * 20 + velikost.X * 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10)
                , new Point(pos.X * 20 + velikost.X * 20 + (pos.Y - 1) * 10 + (velikost.Y + 10), vyska - 40 - patro * 20 - (pos.Y - 1) * 10 -(velikost.Y + 10))
                , new Point(pos.X * 20 + (pos.Y - 1) * 10 + (velikost.Y + 10), vyska - 40 - patro * 20 - (pos.Y - 1) * 10 - (velikost.Y + 10)) });

                //Vyplnovani
                g.FillPolygon(GetColor(barva), new Point[] {new Point(pos.X * 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10)
                , new Point(pos.X * 20 + velikost.X * 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10)
                , new Point(pos.X * 20 + velikost.X * 20 + (pos.Y - 1) * 10 + (velikost.Y + 10), vyska - 40 - patro * 20 - (pos.Y - 1) * 10 -(velikost.Y + 10))
                , new Point(pos.X * 20 + (pos.Y - 1) * 10 + (velikost.Y + 10), vyska - 40 - patro * 20 - (pos.Y - 1) * 10 - (velikost.Y + 10)) });
                //Vykresli horni stenu

                if (pos.X == Velikost.X)
                {
                    g.DrawPolygon(p, new Point[] { new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10 + velikost.X * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10 - velikost.X * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10 + velikost.X * 10, vyska - 20 - patro * 20 - (pos.Y - 1) * 10 - velikost.X * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10, vyska - 20 - patro * 20 - (pos.Y - 1) * 10) });
                    g.FillPolygon(GetColor(barva), new Point[] { new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10 + velikost.X * 10, vyska - 40 - patro * 20 - (pos.Y - 1) * 10 - velikost.X * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10 + velikost.X * 10, vyska - 20 - patro * 20 - (pos.Y - 1) * 10 - velikost.X * 10),
                    new Point(pos.X * 20 + 20 + (pos.Y - 1) * 10, vyska - 20 - patro * 20 - (pos.Y - 1) * 10) });
                    //Vykresli bocni stenu, za predpokladu, ze je kostka v prave krajni strane
                }
            }
            if (pos.Y == 1)
            {
                g.DrawRectangle(p, new Rectangle(pos.X * 20 + (pos.Y - 1) * 10, vyska - 40 - (patro * 20) - (pos.Y - 1) * 10, velikost.X * 20, 20));
                g.FillRectangle(GetColor(barva), new Rectangle(pos.X * 20 + (pos.Y - 1) * 10, vyska - 40 - (patro * 20) - (pos.Y - 1) * 10, velikost.X * 20, 20));
                //Vykresli predni stenu, za predpokladu, ze je kreslena kostka v prvni rade
            }

        }

        private Brush GetColor(char colorChar)
        {
            switch (colorChar)
            {
                case 'A':
                    return Brushes.Cyan; //azurova vypadala jako bila
                case 'R':
                    return Brushes.Red;
                case 'G':
                    return Brushes.Green;
                case 'B':
                    return Brushes.Blue;
                case 'Y':
                    return Brushes.Yellow;
            }
            return Brushes.White;
            //Vrati potrebnou barvu
        }
    }
}
